Index: XIOS/trunk/src/output/nc4_data_output.cpp
===================================================================
--- XIOS/trunk/src/output/nc4_data_output.cpp	(revision 488)
+++ XIOS/trunk/src/output/nc4_data_output.cpp	(revision 498)
@@ -10,4 +10,6 @@
 #include "context.hpp"
 #include "context_server.hpp"
+#include "netCdfException.hpp"
+#include "exception.hpp"
 
 namespace xios
@@ -105,209 +107,222 @@
 */
 
-         switch (SuperClass::type)
-         {
-            case (MULTI_FILE) :
-            {
-//               if (domain->isEmpty()) return;
-
-               if (server->intraCommSize > 1)
-               {
-//                 SuperClassWriter::addDimension(lonid, domain->zoom_ni.getValue());
-//                 SuperClassWriter::addDimension(latid, domain->zoom_nj.getValue());
-               }
-
-               switch (domain->type)
-               {
-                 case CDomain::type_attr::curvilinear :
-                   dim0.push_back(dimYid); dim0.push_back(dimXid);
-                   lonid = StdString("nav_lon").append(appendDomid);
-                   latid = StdString("nav_lat").append(appendDomid);
-                   break ;
-                 case CDomain::type_attr::regular :
-                   lonid = StdString("lon").append(appendDomid);
-                   latid = StdString("lat").append(appendDomid);
-                   dim0.push_back(dimYid);
-                   dim1.push_back(dimXid);
-                   break;
-                 case CDomain::type_attr::unstructured :
-                   lonid = StdString("lon").append(appendDomid);
-                   latid = StdString("lat").append(appendDomid);
-                   bounds_lonid=string("bounds_lon").append(appendDomid);
-                   bounds_latid=string("bounds_lat").append(appendDomid);
-                   dim0.push_back(dimXid);
-                   break;
-               }
-
-               if (domain->type == CDomain::type_attr::unstructured)
-               {
-                 SuperClassWriter::addDimension(dimXid, domain->nj_glo);
-               }
-               else
-               {
-                 SuperClassWriter::addDimension(dimXid, domain->zoom_ni_srv);
-                 SuperClassWriter::addDimension(dimYid, domain->zoom_nj_srv);
-               }
-
-               if (server->intraCommSize > 1)
-               {
-                  if (domain->type != CDomain::type_attr::unstructured)
-                  {
-                    this->writeLocalAttributes(domain->zoom_ibegin_srv,
-                                               domain->zoom_ni_srv,
-                                               domain->zoom_jbegin_srv,
-                                               domain->zoom_nj_srv,
-                                               appendDomid);
-
-                    if (singleDomain) this->writeLocalAttributes_IOIPSL(domain->zoom_ibegin_srv,
-                                               domain->zoom_ni_srv,
-                                               domain->zoom_jbegin_srv,
-                                               domain->zoom_nj_srv,
-                                               domain->ni_glo,domain->nj_glo,
-                                               server->intraCommRank,server->intraCommSize);
-                 }
-               }
-
-               switch (domain->type)
-               {
-                 case CDomain::type_attr::curvilinear :
-                   SuperClassWriter::addVariable(latid, NC_FLOAT, dim0);
-                   SuperClassWriter::addVariable(lonid, NC_FLOAT, dim0);
-                   break ;
-                  case CDomain::type_attr::regular :
-                    SuperClassWriter::addVariable(latid, NC_FLOAT, dim0);
-                    SuperClassWriter::addVariable(lonid, NC_FLOAT, dim1);
-                    break ;
-                  case CDomain::type_attr::unstructured :
-                    SuperClassWriter::addVariable(latid, NC_FLOAT, dim0);
-                    SuperClassWriter::addVariable(lonid, NC_FLOAT, dim0);
-               }
-
-               this->writeAxisAttributes(lonid, "X", "longitude", "Longitude", "degrees_east", domid);
-               this->writeAxisAttributes(latid, "Y", "latitude", "Latitude", "degrees_north", domid);
-
-               dim0.clear();
-               if (domain->type != CDomain::type_attr::unstructured) dim0.push_back(dimYid);
-               dim0.push_back(dimXid);
-
-
-// supress mask               if (server->intraCommSize > 1)
-// supress mask               {
-// supress mask                  SuperClassWriter::addVariable(maskid, NC_INT, dim0);
-// supress mask
-// supress mask                  this->writeMaskAttributes(maskid,
-// supress mask                     domain->data_dim.getValue()/*,
-// supress mask                     domain->data_ni.getValue(),
-// supress mask                     domain->data_nj.getValue(),
-// supress mask                     domain->data_ibegin.getValue(),
-// supress mask                     domain->data_jbegin.getValue()*/);
-// supress mask               }
-
-               //SuperClassWriter::setDefaultValue(maskid, &dvm);
-
-               SuperClassWriter::definition_end();
-
-               switch (domain->type)
-               {
-                 case CDomain::type_attr::curvilinear :
-                   SuperClassWriter::writeData(domain->latvalue_srv, latid, isCollective, 0);
-                   SuperClassWriter::writeData(domain->lonvalue_srv, lonid, isCollective, 0);
-                   break;
-                 case CDomain::type_attr::regular :
-                   CArray<double,1> lat = domain->latvalue_srv(Range(fromStart,toEnd,domain->zoom_ni_srv)) ;
-                   SuperClassWriter::writeData(CArray<double,1>(lat.copy()), latid, isCollective, 0);
-                   CArray<double,1> lon=domain->lonvalue_srv(Range(0,domain->zoom_ni_srv-1)) ;
-                   SuperClassWriter::writeData(CArray<double,1>(lon.copy()), lonid, isCollective, 0);
-                   break;
-               }
-               SuperClassWriter::definition_start();
-
-               break;
-            }
-            case (ONE_FILE) :
-            {
-               SuperClassWriter::addDimension(dimXid, domain->zoom_ni.getValue());
-               SuperClassWriter::addDimension(dimYid, domain->zoom_nj.getValue());
-
-
-               switch (domain->type)
-               {
-                 case CDomain::type_attr::curvilinear :
-                   dim0.push_back(dimYid); dim0.push_back(dimXid);
-                   lonid = StdString("nav_lon").append(appendDomid);
-                   latid = StdString("nav_lat").append(appendDomid);
-                   SuperClassWriter::addVariable(latid, NC_FLOAT, dim0);
-                   SuperClassWriter::addVariable(lonid, NC_FLOAT, dim0);
-                   break;
-
-                 case CDomain::type_attr::regular :
-                   dim0.push_back(dimYid);
-                   dim1.push_back(dimXid);
-                   lonid = StdString("lon").append(appendDomid);
-                   latid = StdString("lat").append(appendDomid);
-                   SuperClassWriter::addVariable(latid, NC_FLOAT, dim0);
-                   SuperClassWriter::addVariable(lonid, NC_FLOAT, dim1);
-                   break;
-               }
-               this->writeAxisAttributes
-                  (lonid, "X", "longitude", "Longitude", "degrees_east", domid);
-               this->writeAxisAttributes
-                  (latid, "Y", "latitude", "Latitude", "degrees_north", domid);
-
-
-               SuperClassWriter::definition_end();
-               switch (domain->type)
-               {
-                 case CDomain::type_attr::curvilinear :
-                 {
-                   std::vector<StdSize> start(2) ;
-                   std::vector<StdSize> count(2) ;
-                   if (domain->isEmpty())
+         try
+         {
+           switch (SuperClass::type)
+           {
+              case (MULTI_FILE) :
+              {
+  //               if (domain->isEmpty()) return;
+
+                 if (server->intraCommSize > 1)
+                 {
+  //                 SuperClassWriter::addDimension(lonid, domain->zoom_ni.getValue());
+  //                 SuperClassWriter::addDimension(latid, domain->zoom_nj.getValue());
+                 }
+
+                 switch (domain->type)
+                 {
+                   case CDomain::type_attr::curvilinear :
+                     dim0.push_back(dimYid); dim0.push_back(dimXid);
+                     lonid = StdString("nav_lon").append(appendDomid);
+                     latid = StdString("nav_lat").append(appendDomid);
+                     break ;
+                   case CDomain::type_attr::regular :
+                     lonid = StdString("lon").append(appendDomid);
+                     latid = StdString("lat").append(appendDomid);
+                     dim0.push_back(dimYid);
+                     dim1.push_back(dimXid);
+                     break;
+                   case CDomain::type_attr::unstructured :
+                     lonid = StdString("lon").append(appendDomid);
+                     latid = StdString("lat").append(appendDomid);
+                     bounds_lonid=string("bounds_lon").append(appendDomid);
+                     bounds_latid=string("bounds_lat").append(appendDomid);
+                     dim0.push_back(dimXid);
+                     break;
+                 }
+
+                 if (domain->type == CDomain::type_attr::unstructured)
+                 {
+                   SuperClassWriter::addDimension(dimXid, domain->nj_glo);
+                 }
+                 else
+                 {
+                   SuperClassWriter::addDimension(dimXid, domain->zoom_ni_srv);
+                   SuperClassWriter::addDimension(dimYid, domain->zoom_nj_srv);
+                 }
+
+                 if (server->intraCommSize > 1)
+                 {
+                    if (domain->type != CDomain::type_attr::unstructured)
+                    {
+                      this->writeLocalAttributes(domain->zoom_ibegin_srv,
+                                                 domain->zoom_ni_srv,
+                                                 domain->zoom_jbegin_srv,
+                                                 domain->zoom_nj_srv,
+                                                 appendDomid);
+
+                      if (singleDomain) this->writeLocalAttributes_IOIPSL(domain->zoom_ibegin_srv,
+                                                 domain->zoom_ni_srv,
+                                                 domain->zoom_jbegin_srv,
+                                                 domain->zoom_nj_srv,
+                                                 domain->ni_glo,domain->nj_glo,
+                                                 server->intraCommRank,server->intraCommSize);
+                   }
+                 }
+
+                 switch (domain->type)
+                 {
+                   case CDomain::type_attr::curvilinear :
+                     SuperClassWriter::addVariable(latid, NC_FLOAT, dim0);
+                     SuperClassWriter::addVariable(lonid, NC_FLOAT, dim0);
+                     break ;
+                    case CDomain::type_attr::regular :
+                      SuperClassWriter::addVariable(latid, NC_FLOAT, dim0);
+                      SuperClassWriter::addVariable(lonid, NC_FLOAT, dim1);
+                      break ;
+                    case CDomain::type_attr::unstructured :
+                      SuperClassWriter::addVariable(latid, NC_FLOAT, dim0);
+                      SuperClassWriter::addVariable(lonid, NC_FLOAT, dim0);
+                 }
+
+                 this->writeAxisAttributes(lonid, "X", "longitude", "Longitude", "degrees_east", domid);
+                 this->writeAxisAttributes(latid, "Y", "latitude", "Latitude", "degrees_north", domid);
+
+                 dim0.clear();
+                 if (domain->type != CDomain::type_attr::unstructured) dim0.push_back(dimYid);
+                 dim0.push_back(dimXid);
+
+
+  // supress mask               if (server->intraCommSize > 1)
+  // supress mask               {
+  // supress mask                  SuperClassWriter::addVariable(maskid, NC_INT, dim0);
+  // supress mask
+  // supress mask                  this->writeMaskAttributes(maskid,
+  // supress mask                     domain->data_dim.getValue()/*,
+  // supress mask                     domain->data_ni.getValue(),
+  // supress mask                     domain->data_nj.getValue(),
+  // supress mask                     domain->data_ibegin.getValue(),
+  // supress mask                     domain->data_jbegin.getValue()*/);
+  // supress mask               }
+
+                 //SuperClassWriter::setDefaultValue(maskid, &dvm);
+
+                 SuperClassWriter::definition_end();
+
+                 switch (domain->type)
+                 {
+                   case CDomain::type_attr::curvilinear :
+                     SuperClassWriter::writeData(domain->latvalue_srv, latid, isCollective, 0);
+                     SuperClassWriter::writeData(domain->lonvalue_srv, lonid, isCollective, 0);
+                     break;
+                   case CDomain::type_attr::regular :
+                     CArray<double,1> lat = domain->latvalue_srv(Range(fromStart,toEnd,domain->zoom_ni_srv)) ;
+                     SuperClassWriter::writeData(CArray<double,1>(lat.copy()), latid, isCollective, 0);
+                     CArray<double,1> lon=domain->lonvalue_srv(Range(0,domain->zoom_ni_srv-1)) ;
+                     SuperClassWriter::writeData(CArray<double,1>(lon.copy()), lonid, isCollective, 0);
+                     break;
+                 }
+                 SuperClassWriter::definition_start();
+
+                 break;
+              }
+              case (ONE_FILE) :
+              {
+                 SuperClassWriter::addDimension(dimXid, domain->zoom_ni.getValue());
+                 SuperClassWriter::addDimension(dimYid, domain->zoom_nj.getValue());
+
+
+                 switch (domain->type)
+                 {
+                   case CDomain::type_attr::curvilinear :
+                     dim0.push_back(dimYid); dim0.push_back(dimXid);
+                     lonid = StdString("nav_lon").append(appendDomid);
+                     latid = StdString("nav_lat").append(appendDomid);
+                     SuperClassWriter::addVariable(latid, NC_FLOAT, dim0);
+                     SuperClassWriter::addVariable(lonid, NC_FLOAT, dim0);
+                     break;
+
+                   case CDomain::type_attr::regular :
+                     dim0.push_back(dimYid);
+                     dim1.push_back(dimXid);
+                     lonid = StdString("lon").append(appendDomid);
+                     latid = StdString("lat").append(appendDomid);
+                     SuperClassWriter::addVariable(latid, NC_FLOAT, dim0);
+                     SuperClassWriter::addVariable(lonid, NC_FLOAT, dim1);
+                     break;
+                 }
+                 this->writeAxisAttributes
+                    (lonid, "X", "longitude", "Longitude", "degrees_east", domid);
+                 this->writeAxisAttributes
+                    (latid, "Y", "latitude", "Latitude", "degrees_north", domid);
+
+
+                 SuperClassWriter::definition_end();
+                 switch (domain->type)
+                 {
+                   case CDomain::type_attr::curvilinear :
                    {
-                     start[0]=0 ; start [1]=0 ;
-                     count[0]=0 ; count[1]=0 ;
+                     std::vector<StdSize> start(2) ;
+                     std::vector<StdSize> count(2) ;
+                     if (domain->isEmpty())
+                     {
+                       start[0]=0 ; start [1]=0 ;
+                       count[0]=0 ; count[1]=0 ;
+                     }
+                     else
+                     {
+                       start[1]=domain->zoom_ibegin_srv-domain->zoom_ibegin.getValue() ; start [0]=domain->zoom_jbegin_srv-domain->zoom_jbegin.getValue() ;
+                       count[1]=domain->zoom_ni_srv ; count[0]=domain->zoom_nj_srv ;
+                     }
+
+                     SuperClassWriter::writeData(domain->latvalue_srv, latid, isCollective, 0,&start,&count);
+                     SuperClassWriter::writeData(domain->lonvalue_srv, lonid, isCollective, 0,&start,&count);
+                     break;
                    }
-                   else
+                   case CDomain::type_attr::regular :
                    {
-                     start[1]=domain->zoom_ibegin_srv-domain->zoom_ibegin.getValue() ; start [0]=domain->zoom_jbegin_srv-domain->zoom_jbegin.getValue() ;
-                     count[1]=domain->zoom_ni_srv ; count[0]=domain->zoom_nj_srv ;
+                     std::vector<StdSize> start(1) ;
+                     std::vector<StdSize> count(1) ;
+                     if (domain->isEmpty())
+                     {
+                       start[0]=0 ;
+                       count[0]=0 ;
+                       SuperClassWriter::writeData(domain->latvalue_srv, latid, isCollective, 0,&start,&count);
+                       SuperClassWriter::writeData(domain->lonvalue_srv, lonid, isCollective, 0,&start,&count);                 }
+                     else
+                     {
+                       start[0]=domain->zoom_jbegin_srv-domain->zoom_jbegin.getValue() ;
+                       count[0]=domain->zoom_nj_srv ;
+                       CArray<double,1> lat = domain->latvalue_srv(Range(fromStart,toEnd,domain->zoom_ni_srv)) ;
+                       SuperClassWriter::writeData(CArray<double,1>(lat.copy()), latid, isCollective, 0,&start,&count);
+
+                       start[0]=domain->zoom_ibegin_srv-domain->zoom_ibegin.getValue() ;
+                       count[0]=domain->zoom_ni_srv ;
+                       CArray<double,1> lon=domain->lonvalue_srv(Range(0,domain->zoom_ni_srv-1)) ;
+                       SuperClassWriter::writeData(CArray<double,1>(lon.copy()), lonid, isCollective, 0,&start,&count);
+                     }
+                     break;
                    }
-
-                   SuperClassWriter::writeData(domain->latvalue_srv, latid, isCollective, 0,&start,&count);
-                   SuperClassWriter::writeData(domain->lonvalue_srv, lonid, isCollective, 0,&start,&count);
-                   break;
-                 }
-                 case CDomain::type_attr::regular :
-                 {
-                   std::vector<StdSize> start(1) ;
-                   std::vector<StdSize> count(1) ;
-                   if (domain->isEmpty())
-                   {
-                     start[0]=0 ;
-                     count[0]=0 ;
-                     SuperClassWriter::writeData(domain->latvalue_srv, latid, isCollective, 0,&start,&count);
-                     SuperClassWriter::writeData(domain->lonvalue_srv, lonid, isCollective, 0,&start,&count);                 }
-                   else
-                   {
-                     start[0]=domain->zoom_jbegin_srv-domain->zoom_jbegin.getValue() ;
-                     count[0]=domain->zoom_nj_srv ;
-                     CArray<double,1> lat = domain->latvalue_srv(Range(fromStart,toEnd,domain->zoom_ni_srv)) ;
-                     SuperClassWriter::writeData(CArray<double,1>(lat.copy()), latid, isCollective, 0,&start,&count);
-
-                     start[0]=domain->zoom_ibegin_srv-domain->zoom_ibegin.getValue() ;
-                     count[0]=domain->zoom_ni_srv ;
-                     CArray<double,1> lon=domain->lonvalue_srv(Range(0,domain->zoom_ni_srv-1)) ;
-                     SuperClassWriter::writeData(CArray<double,1>(lon.copy()), lonid, isCollective, 0,&start,&count);
-                   }
-                   break;
-                 }
-               }
-               SuperClassWriter::definition_start();
-               break;
-            }
-            default :
-               ERROR("CNc4DataOutput::writeDomain(domain)",
-                     << "[ type = " << SuperClass::type << "]"
-                     << " not implemented yet !");
-         }
+                 }
+                 SuperClassWriter::definition_start();
+                 break;
+              }
+              default :
+                 ERROR("CNc4DataOutput::writeDomain(domain)",
+                       << "[ type = " << SuperClass::type << "]"
+                       << " not implemented yet !");
+           }
+         }
+         catch (CNetCdfException& e)
+         {
+           StdString msg("On writing the domain : ");
+           msg.append(domid); msg.append("\n");
+           msg.append("In the context : ");
+           msg.append(context->getId()); msg.append("\n");
+           msg.append(e.what());
+           ERROR("CNc4DataOutput::writeDomain_(CDomain* domain)", << msg);
+         }
+
          domain->addRelFile(this->filename);
       }
